#include <string.h>
#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#define QLEN	70
#define ALEN	40

//#define SHAREWARE

enum DATATYPE {TREEITEM, QUESTION, ANSWER};

class TreeItem
{
	public:
		TreeItem() {father_=0;};
		TreeItem(TreeItem* f) : father_(f) {};
		TreeItem* father() {return father_;};
		void setfather(TreeItem* f) {father_=f;};
		virtual DATATYPE isA() {return TREEITEM;};
		virtual TreeItem* ask() = 0;
		virtual char* gettext() = 0;
		virtual void settext(const char*) = 0;
	protected:
		TreeItem* father_;
};

class Question : public TreeItem
{
	public:
		Question(TreeItem* f, const char* txt);
		~Question() {delete yes_; delete no_;};
		TreeItem* yeschild() {return yes_;};
		TreeItem*  nochild() {return no_;};
		void setyes(TreeItem* yes) {yes_=yes;};
		void  setno(TreeItem* no) {no_=no;};
		char* gettext() {return text;};
		void  settext(const char* txt) {strcpy(text,txt);};
		virtual TreeItem* ask();
		virtual DATATYPE isA() {return QUESTION;};
	protected:
		char text[QLEN];
		TreeItem *yes_, *no_;
};

class Answer : public TreeItem
{
	public:
		Answer(TreeItem* f, const char* txt) : TreeItem(f) {strcpy(text,txt);};
		char* gettext() {return text;};
		void settext(const char* txt) {strcpy(text,txt);};
		virtual DATATYPE isA() {return ANSWER;};
		virtual TreeItem* ask();
	protected:
		char text[ALEN];
};

