#include <stdio.h>
#include <iostream.h>
#include <assert.h>
#include "21qbase.hpp"
#include "21qfile.h"

static FILE* file;
static char file_name[30];
long answers;

void loadfile(Question* root,int nargs,char* args[])
{
	char dummy,data[80];
	if(nargs>2)
	{
		cout << "Syntax:\n    21Q [question-file-name]\n\n";
		exit(5);
	}
	if(nargs==2)
		strcpy(file_name,args[1]);
	else {
		cout << "Enter question file name (e.g. ANIMALS): ";
		cin.get(file_name,30);
		cin.get(dummy);
		if(file_name[0]==0)
			strcpy(file_name,"DEFAULT.21Q");
	}
	if(strstr(file_name,".")==0)
		strcat(file_name,".21Q");
	file = fopen(file_name,"rb");
	if(file==0)
	{
		cout << "File not found - " << file_name << endl;
		exit(6);
	}
	fread(data,1,80,file);
	assert(data[0]=='Q');
	answers=0;
	root->settext(data+9);
	root->setyes(loaditem(*(long*)(data+1),root));
	root->setno(loaditem(*(long*)(data+5),root));
	fclose(file);
	cout << answers << " terms were loaded.\n";
#	ifdef SHAREWARE
	if(answers>150) {
		cout << "This file contains more than 150 terms, which is above the shareware\n"
			 << "term limit. You will not be able to save changes to this file.\n"
			 << "To obtain the full version, which does not have this limitation,\n"
			 << "write e-mail to zvikabh@aluf.technion.ac.il.\n";
	}
#	endif
}

TreeItem* loaditem(long offset, Question* father)
{
	char type,*mem;
	Question *q;
	Answer *a;
	fseek(file,offset,0);
	type = fgetc(file);
	switch(type)
	{
		case 'Q':
			mem = new char[79];
			fread(mem,1,79,file);
			q = new Question(father,mem+8);
			assert(q!=0);
			q->setyes(loaditem(*(long*)mem,q));
			q->setno(loaditem(*(long*)(mem+4),q));
			return q;
		case 'A':
			mem = new char[49];
			fread(mem,1,49,file);
			a = new Answer(father,mem+8);
			answers++;
			assert(a!=0);
			return a;
		default:
			cout << "Bad file format.\n";
			exit(1);
			return 0;
	}
}

void savefile(Question* root)
{
	char fname[30],dummy;
#	ifdef SHAREWARE
	if(answers>150) {
		cout << "The shareware version does not allow saving files once you\n"
			 << "have passed the 150-term limit.\n"
			 << "To obtain the full version, without this limitation, write\n"
			 << "e-mail to zvikabh@aluf.technion.ac.il.\n";
		return;
	}
#	endif
	cout << "Enter file to save questions to ["<<file_name<<"]:\n";
	cin.get(fname,30);
	cin.get(dummy);
	if(fname[0]==0)
		strcpy(fname,file_name);
	file = fopen(fname,"wb");
	assert(file!=0);
	answers=0;
	saveitem(root,0L,80L);
	fclose(file);
	cout << answers << " terms saved.\n";
}

long saveitem(TreeItem* item,long mypos,long lastfree)
{
	char* mem;
	Question *q;
	TreeItem *q2;
	switch(item->isA())
	{
		case QUESTION:
			q=(Question*)item;
			mem=new char[80];
			memset(mem,0,80);
			mem[0]='Q';
			strcpy(mem+9,q->gettext());
			*(long*)(mem+1)=lastfree;
			q2=q->yeschild();
			if((*q2).isA()==QUESTION)
				lastfree=saveitem(q->yeschild(),lastfree,lastfree+80);
			else
				lastfree=saveitem(q->yeschild(),lastfree,lastfree+50);
			*(long*)(mem+5)=lastfree;
			if(q->nochild()->isA()==QUESTION)
				lastfree=saveitem(q->nochild(),lastfree,lastfree+80);
			else
				lastfree=saveitem(q->nochild(),lastfree,lastfree+50);
			fseek(file,mypos,0);
			fwrite(mem,1,80,file);
			break;
		case ANSWER:
			fseek(file,mypos,0);
			mem=new char[50];
			memset(mem,0,50);
			mem[0]='A';
			strcpy(mem+9,item->gettext());
			fwrite(mem,1,50,file);
			answers++;
			break;
		default:
			cout << "Error writing file\n";
			exit(3);
	}
	return lastfree;
}

